# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define distver 5.0
%def_disable gcj_support
%def_disable backport_M4x
%if_enabled backport_M4x
%define %-rpmmacrosdir %_sysconfdir/rpm/macros.d
%endif

Name:           jpackage-utils
Version:        1.7.6
Release:        alt4
Epoch:          0
Summary:        JPackage utilities
License:        JPackage License
URL:            http://www.jpackage.org/
Source0:        %{name}-%{version}.tar

Source1: rpm-build-java.tar
Source2: jpackage-utils-safe.tar
Patch0: %name-enable-gcj-support.patch
Patch1: %name-openjdk-1.7.0-alt-version.patch
Patch2: %name-1.7.4-alt-remove-duplication-of-sys-macros.patch
Patch3: %name-1.7.4-alt-fix-typo-in-comments.patch    
Patch4: jpackage-utils-1.7.5-alt-hasher-support-hack.patch
Patch5: jpackage-utils-1.7.5-alt-undefined-alternatives-during-transaction-hack.patch
Patch6: jpackage-utils-1.7.5-alt-update_maven_depmap-is-obsolete.patch
Patch7: jpackage-utils-1.7.5-alt-rpmscript-safe-mode.patch

Requires:       rpm-build-java = %{version}-%{release}

Group:          Development/Java
Packager:       Java Maintainers Team <java@packages.altlinux.org>

BuildArch:      noarch
AutoReqProv:    no
BuildRequires:  awk, grep
Requires:       /bin/egrep
Requires:       /bin/sed
Requires:       /usr/bin/perl

%description
Utilities for the JPackage Project <http://www.jpackage.org/>:

* %{_bindir}/build-classpath
                                build the Java classpath in a portable manner
* %{_bindir}/build-jar-repository
                                build a jar repository in a portable manner
* %{_bindir}/rebuild-jar-repository
                                rebuild a jar repository in a portable manner
                                (after a jvm change...)
* %{_bindir}/build-classpath-directory
                                build the Java classpath from a directory
* %{_bindir}/diff-jars
                                show jar content differences
* %{_bindir}/jvmjar
                                install jvm extensions
* %{_bindir}/create-jar-links
                                create custom jar links
* %{_bindir}/clean-binary-files
                                remove binary files from sources
* %{_bindir}/check-binary-files
                                check for presence of unexpected binary files
* %{_datadir}/java-utils/java-functions
                                shell script functions library for Java
                                applications
* %{_sysconfdir}/java/jpackage-release
                                string identifying the currently installed
                                JPackage release
* %{_sysconfdir}/java/java.conf
                                system-wide Java configuration file
* %{_sysconfdir}/rpm/macros.d/jpackage
                                RPM macros for Java packagers and developers
* %{_docdir}/%{name}-%{version}/jpackage-policy
                                Java packaging policy for packagers and
                                developers

It contains also the License, man pages, documentation, XSL files of general
use with maven2, a header file for spec files etc.

%package -n rpm-build-java
Summary: RPM helper macros to build Java packages
Group: Development/Java
License: JPackage License

%description -n rpm-build-java
These helper macros facilitate creation of RPM packages containing Java
bytecode archives and Javadoc documentation.

%prep
%setup -q -a1 -a2

%if_enabled gcj_support
%patch0 -p0
%endif
%patch1 -p2
%patch2 -p2
%patch3 -p2
%patch4 -p2
%if_disabled backport_M4x
%patch5 -p2
%endif
%patch6 -p2
%patch7 -p2

%build
echo "JPackage release %{distver} (%distribution) for %buildarch" \
 > etc/jpackage-release

%install
# Pull macros out of macros.jpackage and emulate them during install for
# smooth bootstrapping experience.
for dir in \
    jvmdir jvmjardir jvmprivdir \
    jvmlibdir jvmdatadir jvmsysconfdir \
    jvmcommonlibdir jvmcommondatadir jvmcommonsysconfdir \
    javadir jnidir javadocdir mavendepmapdir; do
  export _${dir}=$(rpm --eval $(grep -E "^%%_${dir}\b" misc/macros.jpackage | awk '{ print $2 }'))
done

install -dm 755 ${RPM_BUILD_ROOT}%{_bindir}
install -dm 755 ${RPM_BUILD_ROOT}%{_sysconfdir}/java
%if_enabled gcj_support
install -dm 755 ${RPM_BUILD_ROOT}%{_sysconfdir}/java/security
install -dm 755 ${RPM_BUILD_ROOT}%{_sysconfdir}/java/security/security.d
%endif
install -dm 755 ${RPM_BUILD_ROOT}${_jvmdir}
install -dm 755 ${RPM_BUILD_ROOT}${_jvmjardir}
install -dm 755 ${RPM_BUILD_ROOT}${_jvmprivdir}
install -dm 755 ${RPM_BUILD_ROOT}${_jvmlibdir}
install -dm 755 ${RPM_BUILD_ROOT}${_jvmdatadir}
install -dm 755 ${RPM_BUILD_ROOT}${_jvmsysconfdir}
install -dm 755 ${RPM_BUILD_ROOT}${_jvmcommonlibdir}
install -dm 755 ${RPM_BUILD_ROOT}${_jvmcommondatadir}
install -dm 755 ${RPM_BUILD_ROOT}${_jvmcommonsysconfdir}
install -dm 755 ${RPM_BUILD_ROOT}${_javadir}
install -dm 755 ${RPM_BUILD_ROOT}${_jnidir}
install -dm 755 ${RPM_BUILD_ROOT}${_javadir}-{utils,ext,1.3.1,1.4.0,1.4.1,1.4.2,1.5.0,1.6.0,1.7.0}
install -dm 755 ${RPM_BUILD_ROOT}${_jnidir}-{ext,1.3.1,1.4.0,1.4.1,1.4.2,1.5.0,1.6.0,1.7.0}
install -dm 755 ${RPM_BUILD_ROOT}${_javadocdir}
install -dm 755 ${RPM_BUILD_ROOT}${_mavendepmapdir}

%if_enabled gcj_support
cat > bin/rebuild-security-providers << EOF
#!/bin/bash
# Rebuild the list of security providers in classpath.security

secfiles="/usr/lib/security/classpath.security /usr/lib64/security/classpath.security"

for secfile in \$secfiles; do
  # check if this classpath.security file exists
  [ -f "\$secfile" ] || continue

  sed -i '/^security\.provider\./d' "\$secfile"

  count=0
  for provider in \$(ls /etc/java/security/security.d)
  do
    count=\$((count + 1))
    echo "security.provider.\${count}=\${provider#*-}" >> "\$secfile"
  done
done
EOF
%endif

install -pm 755 bin/* ${RPM_BUILD_ROOT}%_bindir
install -pm 644 etc/font.properties ${RPM_BUILD_ROOT}%_sysconfdir/java

# Create an initial (empty) depmap
echo -e "<dependencies>\\n" > ${RPM_BUILD_ROOT}${_mavendepmapdir}/maven2-depmap.xml
echo -e "</dependencies>\\n" >> ${RPM_BUILD_ROOT}${_mavendepmapdir}/maven2-depmap.xml

cat > etc/java.conf << EOF
# System-wide Java configuration file                                -*- sh -*-
#
# JPackage Project <http://www.jpackage.org/>

# Location of jar files on the system
JAVA_LIBDIR=${_javadir}

# Location of arch-specific jar files on the system
JNI_LIBDIR=${_jnidir}

# Root of all JVM installations
JVM_ROOT=${_jvmdir}

# You can define a system-wide JVM root here if you're not using the default one
#JAVA_HOME=\$JVM_ROOT/java

# Options to pass to the java interpreter
JAVACMD_OPTS=
EOF

install -pm 644 etc/java.conf ${RPM_BUILD_ROOT}%{_sysconfdir}/java
install -pm 644 etc/jpackage-release ${RPM_BUILD_ROOT}%{_sysconfdir}/java
install -pm 644 java-utils/* ${RPM_BUILD_ROOT}${_javadir}-utils

%{__mkdir_p} ${RPM_BUILD_ROOT}%_rpmmacrosdir
install -pm 644 misc/macros.jpackage ${RPM_BUILD_ROOT}%_rpmmacrosdir/jpackage
%{__mkdir_p} ${RPM_BUILD_ROOT}%_man1dir/
install -pm 644 man/* ${RPM_BUILD_ROOT}%_man1dir/
%{__mkdir_p} ${RPM_BUILD_ROOT}${_javadir}-utils/xml
install -pm 644 xml/* ${RPM_BUILD_ROOT}${_javadir}-utils/xml

cat <<EOF > %{name}-%{version}.files
%%dir %_sysconfdir/java
%%dir $_jvmdir
%%dir $_jvmjardir
%%dir $_jvmprivdir
%%dir $_jvmdatadir
%%dir $_jvmsysconfdir
%%dir $_jvmcommonlibdir
%%dir $_jvmcommondatadir
%%dir $_jvmcommonsysconfdir
%%dir $_javadir
%%dir $_javadir-*
%%dir $_jnidir
%%dir $_jnidir-*
%%dir $_javadocdir
%%dir $_mavendepmapdir
$_javadir-utils/*
%%config %_sysconfdir/java/jpackage-release
%%config(noreplace) %_sysconfdir/java/java.conf
%%config(noreplace) %_sysconfdir/java/font.properties
%%config(noreplace) $_mavendepmapdir/maven2-depmap.xml
EOF


%if_enabled backport_M4x
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/rpm/macros.d/
install -pm 644 rpm-build-java/rpm-build-java.macros ${RPM_BUILD_ROOT}%{_sysconfdir}/rpm/macros.d/ant-deprecated
%endif

%{__mkdir_p} ${RPM_BUILD_ROOT}/usr/lib/rpm/
install -pm 755 rpm-build-java/osgi.prov* ${RPM_BUILD_ROOT}/usr/lib/rpm/
pushd ${RPM_BUILD_ROOT}/usr/lib/rpm/
# un/comment ln's below to enable/disable osgi.req
      ln -s osgi.prov osgi.req
      ln -s osgi.prov.files osgi.req.files
popd

# ------------- safe jpackage utils --------------------
install -pm 644 jpackage-utils-safe/java-functions-safe ${RPM_BUILD_ROOT}${_javadir}-utils
#install -pm 755 jpackage-utils-safe/safe-*build-jar-repository ${RPM_BUILD_ROOT}%_bindir/
# ------------- end safe jpackage utils ----------------

# -------- update-maven-depmap.filetrigger ---------------
%__mkdir_p %buildroot/%_rpmlibdir/
export _mavendepmapfragdir=$(rpm --eval $(grep -E "^%%_mavendepmapfragdir\b" misc/macros.jpackage | awk '{ print $2 }'))
%__cat <<__TRIGGER__ >%buildroot/%_rpmlibdir/update-maven-depmap.filetrigger
#!/bin/sh -e
grep -qs -e '^$_mavendepmapfragdir/' || exit 0
echo '<dependencies>' > $_mavendepmapdir/maven2-depmap.xml;
if [ -d $_mavendepmapfragdir ] && [ -n "\`find $_mavendepmapfragdir -type f\`" ]; then
  cat $_mavendepmapfragdir/* >> $_mavendepmapdir/maven2-depmap.xml
fi
echo '</dependencies>' >> $_mavendepmapdir/maven2-depmap.xml
__TRIGGER__
echo '%%attr(755,root,root) %_rpmlibdir/update-maven-depmap.filetrigger' >> %{name}-%{version}.files
# -------- end update-maven-depmap.filetrigger ---------------


%post
# -------- update-maven-depmap.filetrigger ---------------
%define _mavendepmapdir /etc/maven%nil
%define _mavendepmapfragdir /etc/maven/fragments%nil
echo '<dependencies>' > %_mavendepmapdir/maven2-depmap.xml;
if [ -d %_mavendepmapfragdir ] && [ -n "\`find $_mavendepmapfragdir -type f\`" ]; then
  cat %_mavendepmapfragdir/* >> %_mavendepmapdir/maven2-depmap.xml
fi
echo '</dependencies>' >> %_mavendepmapdir/maven2-depmap.xml
# -------- end update-maven-depmap.filetrigger ---------------

%files -f %{name}-%{version}.files
%_bindir/*
%_mandir/man1/*
%doc LICENSE.txt HEADER.JPP doc/* etc/httpd-javadoc.conf
%doc jpackage-utils-safe/README.ALT
%if_enabled gcj_support
%_sysconfdir/java/security
%_sysconfdir/java/security/security.d
%endif

%files -n rpm-build-java
%if_enabled backport_M4x
%_sysconfdir/rpm/macros.d/ant-deprecated
%endif
%_rpmmacrosdir/jpackage
/usr/lib/rpm/osgi.*

%changelog
* Mon Feb 23 2009 Igor Vlasenko <viy@altlinux.ru> 0:1.7.6-alt4
- removed useless warning in safe mode support patch

* Wed Feb 18 2009 Igor Vlasenko <viy@altlinux.ru> 0:1.7.6-alt3
- safe mode for *build-jar-repository inside rpm scripts

* Mon Jan 12 2009 Igor Vlasenko <viy@altlinux.ru> 0:1.7.6-alt2
- fix in osgi.req (optional dependencies are now skipped)

* Sun Dec 21 2008 Igor Vlasenko <viy@altlinux.ru> 0:1.7.6-alt1
- update_maven_depmap made as a filetrigger
- future support of $RPM_FORCE_UPDATE_ALTERNATIVES
- fix in osgi.prov (empty line as separator support)

* Wed Nov 26 2008 Igor Vlasenko <viy@altlinux.ru> 0:1.7.5-alt11
- support for M4x backports

* Tue Nov 25 2008 Igor Vlasenko <viy@altlinux.ru> 0:1.7.5-alt10
- dirty hack until migration to new alternatives will be finished
  (jpackage-utils-1.7.5-alt-undefined-alternatives-during-transaction-hack)

* Mon Nov 17 2008 Igor Vlasenko <viy@altlinux.ru> 0:1.7.5-alt9
- added jpackage-utils-1.7.5-alt-hasher-support-hack.patch

* Thu Oct 30 2008 Igor Vlasenko <viy@altlinux.ru> 0:1.7.5-alt8
- removed ant.deprecated macros 
- range support in osgi.req

* Sat Jul 26 2008 Igor Vlasenko <viy@altlinux.ru> 0:1.7.5-alt6
- enabled osgi.req*

* Thu Jul 17 2008 Igor Vlasenko <viy@altlinux.ru> 0:1.7.5-alt5
- renamed ant.deprecated to ant-deprecated (not to be ignored)

* Wed Jul 02 2008 Igor Vlasenko <viy@altlinux.ru> 0:1.7.5-alt4
- enabled osgi.prov* (osgi.req* symlinks are still disabled)

* Wed Jul 02 2008 Igor Vlasenko <viy@altlinux.ru> 0:1.7.5-alt3
- added osgi.prov* (osgi.req* symlinks are still disabled)

* Wed May 28 2008 Igor Vlasenko <viy@altlinux.ru> 0:1.7.5-alt2
- rpm-build-java is now built from jpackage-utils

* Wed May 28 2008 Igor Vlasenko <viy@altlinux.ru> 0:1.7.5-alt1
- sync'ed with jpackage 1.7.5 1jpp.
- removed BuildRequires rpm-build-java

* Wed Feb 13 2008 Igor Vlasenko <viy@altlinux.ru> 0:1.7.4-alt2
- Do not override system macros (#12223) - made as external patch
- removed Requires rpm-build-java. (buildrequires is still left).
  The right way should be that rpm-build-java will Requires 
  and buildrequires jpackage-utils, or even will provide them.

* Tue Feb 12 2008 Igor Vlasenko <viy@altlinux.ru> 0:1.7.4-alt1
- new version

* Tue Nov 20 2007 Igor Vlasenko <viy@altlinux.ru> 0:1.7.3-alt6
- fixed openjdk misdetection

* Sun Jul 29 2007 Damir Shayhutdinov <damir@altlinux.ru> 0:1.7.3-alt5
- Added directory for Java 1.7.0 (openjdk) #12409

* Sun Jul 08 2007 Damir Shayhutdinov <damir@altlinux.ru> 0:1.7.3-alt4
- Do not override system macros (#12223)
- Requires and buildrequires rpm-build-java

* Fri Apr 06 2007 Damir Shayhutdinov <damir@altlinux.ru> 0:1.7.3-alt3
- Disabled gcj support 

* Mon Feb 12 2007 Damir Shayhutdinov <damir@altlinux.ru> 0:1.7.3-alt2
- Some spec cleanup 

* Wed Feb 07 2007 Damir Shayhutdinov <damir@altlinux.ru> 0:1.7.3-alt1
- Initial build for ALT Linux (based on Fedora 6 spec)

